//
//  CDAppDelegate.m
//  Dropkick
//
//  Created by Jonathan LaCour on 2/25/13.
//  Copyright (c) 2013 Jonathan LaCour. All rights reserved.
//

#import "CDAppDelegate.h"
#import <Foundation/Foundation.h>

@implementation CDAppDelegate

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{    
    NSUserDefaults *preferences = [NSUserDefaults standardUserDefaults];
    [_accessKey setStringValue: [preferences stringForKey:@"accessKey"]];
    [_secretKey setStringValue: [preferences stringForKey:@"secretKey"]];
    [_bucketName setStringValue: [preferences stringForKey:@"bucketName"]];
}

- (void)application:(NSApplication *)sender openFiles:(NSArray *) fileNames {
    
    NSUserDefaults *preferences = [NSUserDefaults standardUserDefaults];
    [preferences setObject: [_accessKey stringValue] forKey: @"accessKey"];
    [preferences setObject: [_secretKey stringValue] forKey: @"secretKey"];
    [preferences setObject: [_bucketName stringValue] forKey: @"bucketName"];
    
    NSString* copyScript = [[NSBundle mainBundle] pathForResource:@"upload-file" ofType:@"py"];
    NSString* botoPath = [[NSBundle mainBundle] pathForResource:@"boto-2.8.0-py2.7" ofType:@"egg"];
    
    NSDictionary* env = @{
        @"PYTHONPATH": botoPath,
        @"ACCESSKEY": [_accessKey stringValue],
        @"SECRETKEY": [_secretKey stringValue],
        @"BUCKETNAME": [_bucketName stringValue]
    };
        
    NSTask* task = [NSTask new];
    [task setCurrentDirectoryPath: botoPath];
    [task setLaunchPath: @"/usr/bin/env"];
    [task setEnvironment: env];
    [task setArguments: [NSArray arrayWithObjects: @"python", copyScript, fileNames[0], nil]];
    
    NSPipe *pipe = [NSPipe pipe];
    [task setStandardOutput:pipe];
    
    [task launch];
    [task waitUntilExit];
    
    NSData *data = [[pipe fileHandleForReading] readDataToEndOfFile];
    NSString *string = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
}

@end
