#!/usr/bin/env python

#  upload-file.py
#  Dropkick
#
#  Created by Jonathan LaCour on 2/25/13.
#  Copyright (c) 2013 Jonathan LaCour. All rights reserved.

import os, sys

from contextlib import closing

import boto
import boto.s3.connection


dhdo_access_key = os.environ['ACCESSKEY']
dhdo_secret_key = os.environ['SECRETKEY']
dhdo_screenshots_bucket = os.environ['BUCKETNAME']


with closing(open(sys.argv[1])) as f:
    
    if not os.path.exists(f.name): sys.exit(0)
    
    connection = boto.connect_s3(aws_access_key_id=dhdo_access_key,
                                 aws_secret_access_key=dhdo_secret_key,
                                 host='objects.dreamhost.com')
    
    bucket = connection.get_bucket(dhdo_screenshots_bucket)

    key_name = f.name.rsplit('/', 1)[1]
    key = bucket.new_key(key_name)
    key.set_contents_from_filename(f.name)
    key.set_canned_acl('public-read')
    
    public_url = key.generate_url(0, query_auth=False, force_http=True)
    
    os.system('echo "%s" | pbcopy' % public_url)